'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var __chunk_1 = require('./chunk-5aad1f72.js');
var emotion = require('emotion');
var darken = require('reakit-system-palette/utils/darken');
var contrast = require('reakit-system-palette/utils/contrast');
var palette = require('reakit-system-palette/utils/palette');

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    position: relative;\n    outline: 0;\n\n    &[aria-checked=\"true\"] {\n      &:before {\n        content: \"\u2022\";\n        position: absolute;\n        font-size: 1.4em;\n        top: -0.25em;\n        left: 0.3em;\n        width: 0.7142857143em;\n        height: 0.7142857143em;\n      }\n    }\n  "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    position: relative;\n    outline: 0;\n\n    &[aria-checked=\"true\"] {\n      &:before {\n        content: \"\u2713\";\n        position: absolute;\n        top: 0;\n        left: 0.4em;\n        width: 1em;\n        height: 1em;\n      }\n    }\n  "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      &:after {\n      content: \"", "\";\n      position: absolute;\n      font-size: 0.7em;\n      line-height: inherit;\n      padding: 0.42em 0;\n      ", ": 0.75em;\n    }"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n          padding-right: 1.6em;\n        "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    position: relative;\n\n    *:not([aria-orientation=\"horizontal\"]) > & {\n      ", "\n      ", "\n    }\n  "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    display: flex;\n    border-radius: 0;\n\n    &:not([aria-orientation=\"horizontal\"]) > &[aria-orientation=\"vertical\"] {\n      margin-top: -0.3em;\n    }\n  "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    &&& {\n      line-height: 1.5;\n      padding: 0 ", ";\n      text-align: left;\n      border: 0;\n      border-radius: 0;\n      font-size: 100%;\n      background: transparent;\n      color: ", ";\n      margin: 0;\n      user-select: none;\n\n      &:focus,\n      &[aria-expanded=\"true\"] {\n        background-color: ", ";\n        color: ", ";\n        box-shadow: none !important;\n      }\n\n      &:active {\n        background-color: ", " !important;\n      }\n    }\n  "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    display: flex;\n    flex-direction: ", ";\n    white-space: nowrap;\n\n    &[aria-orientation=\"vertical\"] {\n      padding: 0.25em 0;\n    }\n\n    &[aria-orientation=\"horizontal\"] {\n      padding: 0;\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
function useStaticMenuProps(options, _ref) {
  if (_ref === void 0) {
    _ref = {};
  }

  var _ref2 = _ref,
      className = _ref2.className,
      htmlProps = __chunk_1._objectWithoutPropertiesLoose(_ref2, ["className"]);

  var isHorizontal = options.orientation === "horizontal";
  var staticMenu = emotion.css(_templateObject(), isHorizontal ? "row" : "column");
  return __chunk_1._objectSpread({}, htmlProps, {
    className: emotion.cx(className, staticMenu)
  });
}
function useMenuItemProps(_ref4, _ref3) {
  if (_ref3 === void 0) {
    _ref3 = {};
  }

  var unstable_system = _ref4.unstable_system,
      options = __chunk_1._objectWithoutPropertiesLoose(_ref4, ["unstable_system"]);

  var _ref5 = _ref3,
      className = _ref5.className,
      htmlProps = __chunk_1._objectWithoutPropertiesLoose(_ref5, ["className"]);

  var foreground = palette.usePalette("foreground") || "black";
  var primary = palette.usePalette("primary") || "blue";
  var primaryContrast = contrast.useContrast(primary);
  var darkPrimary = darken.useDarken(primary, 0.2);
  var isHorizontal = options.orientation === "horizontal";
  var menuItem = emotion.css(_templateObject2(), isHorizontal ? "0.5em" : "1.5em", foreground, primary, primaryContrast, darkPrimary);
  return __chunk_1._objectSpread({}, htmlProps, {
    className: emotion.cx(className, menuItem)
  });
}
function useMenuOptions(_ref6) {
  var _ref6$unstable_system = _ref6.unstable_system;
  _ref6$unstable_system = _ref6$unstable_system === void 0 ? {} : _ref6$unstable_system;

  var _ref6$unstable_system2 = _ref6$unstable_system.palette,
      palette = _ref6$unstable_system2 === void 0 ? "background" : _ref6$unstable_system2,
      _ref6$unstable_system3 = _ref6$unstable_system.fill,
      fill = _ref6$unstable_system3 === void 0 ? "opaque" : _ref6$unstable_system3,
      system = __chunk_1._objectWithoutPropertiesLoose(_ref6$unstable_system, ["palette", "fill"]),
      options = __chunk_1._objectWithoutPropertiesLoose(_ref6, ["unstable_system"]);

  return __chunk_1._objectSpread({
    unstable_system: __chunk_1._objectSpread({
      palette: palette,
      fill: fill
    }, system)
  }, options);
}
function useMenuProps(_, _ref7) {
  if (_ref7 === void 0) {
    _ref7 = {};
  }

  var _ref8 = _ref7,
      className = _ref8.className,
      htmlProps = __chunk_1._objectWithoutPropertiesLoose(_ref8, ["className"]);

  var menu = emotion.css(_templateObject3());
  return __chunk_1._objectSpread({}, htmlProps, {
    className: emotion.cx(className, menu)
  });
}
function useMenuDisclosureProps(options, _ref9) {
  if (_ref9 === void 0) {
    _ref9 = {};
  }

  var _ref10 = _ref9,
      className = _ref10.className,
      htmlProps = __chunk_1._objectWithoutPropertiesLoose(_ref10, ["className"]);

  var dir = options.placement ? options.placement.split("-")[0] : undefined;
  var arrowMap = {
    top: "▲",
    right: "▶",
    bottom: "▼",
    left: "◀"
  };
  var menuDisclosure = emotion.css(_templateObject4(), dir !== "left" && emotion.css(_templateObject5()), dir && emotion.css(_templateObject6(), arrowMap[dir], dir === "left" ? "left" : "right"));
  return __chunk_1._objectSpread({}, htmlProps, {
    className: emotion.cx(className, menuDisclosure)
  });
}
function useMenuItemCheckboxProps(_, _ref11) {
  if (_ref11 === void 0) {
    _ref11 = {};
  }

  var _ref12 = _ref11,
      className = _ref12.className,
      htmlProps = __chunk_1._objectWithoutPropertiesLoose(_ref12, ["className"]);

  var menuItemCheckbox = emotion.css(_templateObject7());
  return __chunk_1._objectSpread({}, htmlProps, {
    className: emotion.cx(className, menuItemCheckbox)
  });
}
function useMenuItemRadioProps(_, _ref13) {
  if (_ref13 === void 0) {
    _ref13 = {};
  }

  var _ref14 = _ref13,
      className = _ref14.className,
      htmlProps = __chunk_1._objectWithoutPropertiesLoose(_ref14, ["className"]);

  var menuItemRadio = emotion.css(_templateObject8());
  return __chunk_1._objectSpread({}, htmlProps, {
    className: emotion.cx(className, menuItemRadio)
  });
}

exports.useMenuDisclosureProps = useMenuDisclosureProps;
exports.useMenuItemCheckboxProps = useMenuItemCheckboxProps;
exports.useMenuItemProps = useMenuItemProps;
exports.useMenuItemRadioProps = useMenuItemRadioProps;
exports.useMenuOptions = useMenuOptions;
exports.useMenuProps = useMenuProps;
exports.useStaticMenuProps = useStaticMenuProps;
